package cn.timer.api.utils.router.business;

import java.text.ParseException;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONObject;
import cn.timer.api.controller.kqgl.service.KqglService;
import cn.timer.api.dto.kqmk.AttEvectionApprovalDto;
import cn.timer.api.dto.spmk.FromData;
import cn.timer.api.utils.DateUtil;
import lombok.Builder;

/**
 * 出差-业务
 * @author Tang
 *
 */
@Service
public class EvectionBusiness extends SpmkAssoBusiness {

	@Autowired
	private KqglService kqglService;
	
	@Override
	public void handleApprove(JSONObject jsonObj) throws ParseException {
		// TODO Auto-generated method stub
		// 发起人企业id
		Integer orgCode = ObjectUtil.isNull(jsonObj.get("orgCode")) ? null : Convert.toInt(jsonObj.get("orgCode"));
		// 发起人id
		Integer id = ObjectUtil.isNull(jsonObj.get("id",FromData.class)) ? null : Integer.parseInt(jsonObj.get("id",FromData.class).getValue());
		// 发起人名称
		String initiator = ObjectUtil.isNull(jsonObj.get("initiator",FromData.class)) ? null : jsonObj.get("initiator",FromData.class).getValue();
		
		// 审批汇总id
		String approveId = ObjectUtil.isNull(jsonObj.get("approveId",FromData.class)) ? null : jsonObj.get("approveId",FromData.class).getValue();
		// 开始时间
		String startTime = ObjectUtil.isNull(jsonObj.get("__startTime",FromData.class)) ? null : jsonObj.get("__startTime",FromData.class).getValue();
		// 结束时间
		String endTime = ObjectUtil.isNull(jsonObj.get("__endTime",FromData.class)) ? null : jsonObj.get("__endTime",FromData.class).getValue();
		// 时长
		String longTime = ObjectUtil.isNull(jsonObj.get("__longTime",FromData.class)) ? null : jsonObj.get("__longTime",FromData.class).getValue();
		// 出差事由
		String businessTrip = ObjectUtil.isNull(jsonObj.get("__businessTrip",FromData.class)) ? null : jsonObj.get("__businessTrip",FromData.class).getValue();
		// 上传文件
		String UploadAttachment = ObjectUtil.isNull(jsonObj.get("UploadAttachment",FromData.class)) ? null : jsonObj.get("UploadAttachment",FromData.class).getValue();
		System.out.println(approveId);
		AttEvectionApprovalDto eaD = AttEvectionApprovalDto
				.builder()
				.userid(id)
				.orgcode(orgCode)
				.evectionid(Convert.toInt(approveId))
				.evectiontype(1)
				.starttime(DateUtil.getStringTime(startTime, "yyyy-MM-dd HH:mm:ss"))
				.endtime(DateUtil.getStringTime(endTime, "yyyy-MM-dd HH:mm:ss"))
				.duration(Convert.toDouble(longTime))
				.build();
	
		System.out.println("出差:" + eaD);
		
		// 调 考勤管理 业务-出差
		kqglService.attevectionapproval(eaD);
	}

}
